/*
****************************
* Linefollower Grzmot v2.0 *
****************************
*/
#include <PID_v1.h>


//***DEFINICJE***
#define zolta 10
#define zielona 11
#define I1 5
#define I2 4
#define I3 8
#define I4 7
#define E1 6
#define E2 9
#define Switch 3
#define Sharp 2

//***Zmienne***
//zmienne jazdy
int lewy = 0;
int prawy = 0;
//tablica czujnikow
int czujniki[5];
//tabica wag
int wagi[5] = {20, 10, 0, -10, -20};
//granica
int granica = 700;  
//flaga przestrzelenia zakretu
int ostatni = 0; // ostatnio widziana linia pod danym czujnikiem
//zmienne dla PD
double Setpoint = 0;
double Input;
double Output;
double Kp = 6; 
double Ki = 0;
double Kd = 14;
//podstawa predkosci
int V_zad = 80;
//napiecie
float napiecie = 0;
int odczyt = 0;
//flaga sharpa
bool fSharp = true;
//flaga zasilania
bool fnapiecie = false;
//zmienne czas
unsigned long previousMillis = 0;
const long przerwa = 100; 
//flaga bezpiecznika
bool bezpiecznik = false;
//sztuczny delay
int dilej = 500;
//blad
int Blad = 0;
//poprzedni blad
int poprzedni_blad = 0;

PID pid(&Input, &Output, &Setpoint, Kp, Ki, Kd, DIRECT);

void setup() {

  Serial.begin(115200);
  pinMode(zolta, OUTPUT);
  pinMode(zielona, OUTPUT);
  pinMode(I1, OUTPUT);
  pinMode(I2, OUTPUT);
  pinMode(I3, OUTPUT);
  pinMode(I4, OUTPUT);
  pinMode(Switch, INPUT_PULLUP);
  pinMode(E1, OUTPUT);
  pinMode(E2, OUTPUT);
  pinMode(Sharp, INPUT_PULLUP);
  digitalWrite(zolta, HIGH);
  digitalWrite(zielona, HIGH);
  attachInterrupt(digitalPinToInterrupt(2), sharp, FALLING); //przerwanie od sharpa
  //lewy = 60;
  //prawy = 60;
  pid.SetMode(AUTOMATIC);
  pid.SetSampleTime(10);
  pid.SetOutputLimits(-100, 100);
}

void loop() { //********************************************************
  unsigned long currentMillis = millis();
  czyBezpiecznie();
  czytajADC();
  Blad = licz_blad();
  Input = Blad;
  pid.Compute();
  if(bezpiecznik == true){
    wysteruj(V_zad - Output, V_zad + Output);
  }
  else{
    wysteruj(0, 0);
  }
  
  serialLogger();
}

//funkcje

void czytajADC() { //sprawdzone i dziala 
czujniki[0] = analogRead(A0);
czujniki[1] = analogRead(A1);
czujniki[2] = analogRead(A2);
czujniki[3] = analogRead(A3);
czujniki[4] = analogRead(A4);
/*Serial.print(czujniki[0]);
Serial.print(" ");
Serial.print(czujniki[1]);
Serial.print(" ");
Serial.print(czujniki[2]);
Serial.print(" ");
Serial.print(czujniki[3]);
Serial.print(" ");
Serial.println(czujniki[4]);*/

  for(int i = 0; i<5; i++)
    {
      if(czujniki[i] > granica)
        czujniki[i] = 1;
      else 
        czujniki[i] = 0;     
    }  
}

void czyBezpiecznie(){
  unsigned long aktualny = millis();
  bool stan = 0;
  odczyt = analogRead(A5);
  napiecie = odczyt * (10.0/1023.0);
  if(napiecie <= 8.10)
    fnapiecie = false; 
    
  else 
    fnapiecie = true;

  if(fSharp == true || fnapiecie == false){
    bezpiecznik = false;
    //opoznienie do migania diodami bez delay();
    if(aktualny - previousMillis >= dilej) {
      digitalWrite(zolta, !stan);
      digitalWrite(zielona, stan);
    }
  }
  else {
    bezpiecznik = true;
    digitalWrite(zolta, 1);
    digitalWrite(zielona, 1);
  }
  
}

void serialLogger(){
  Serial.print("Napiecie: ");
  Serial.print(napiecie);
  Serial.print(" Czujniki linii: ");
  for(int i = 0; i<5; i++){
    Serial.print(czujniki[i]);
    Serial.print(" ");
  }
  Serial.print("");
  Serial.print(" Sharp: ");
  Serial.print(fSharp);
  Serial.println("");
  Serial.print(" Napiecie: ");
  Serial.print(fnapiecie);
  Serial.print(" Bezpiecznik: ");
  Serial.print(bezpiecznik);
  Serial.print(" Blad: ");
  Serial.print(Blad);
  Serial.print(" Output ");
  Serial.print(Output);

  if(bezpiecznik == false){
    Serial.print(" nie jedziemy ");
  }
  else Serial.print(" jazda ");
}

void wysteruj(int lewy, int prawy) { // sprawdzone i dziala 
  if(lewy  >= 0)
  {
    if(lewy > 255)
        lewy = 255;
    digitalWrite(I1, 1);
    digitalWrite(I2, 0); 
    }
    else 
    {
      if (lewy < -255)
        lewy = -255;
      digitalWrite(I1, 0);
      digitalWrite(I2, 1);
      }
    analogWrite(E1, lewy); 
  
  if(prawy  >= 0)
    {
      if(prawy > 255)
          prawy = 255;
      
      digitalWrite(I3, 1);
      digitalWrite(I4, 0); 
      }
      else 
      {
        if (prawy < -255)
          prawy = -255;
        digitalWrite(I3, 0);
        digitalWrite(I4, 1);
        }
      
      analogWrite(E2, prawy); 
}

void sharp() {
  //Serial.println("sharp widzi!");
  fSharp = !fSharp; // jednorazowe widzenie sharpa wylacza jazde
}

int licz_blad(){
  int blad = 0;
  int ilosc_linii = 0;
  for(int i = 0; i<5; i++){
    blad = blad + czujniki[i] * wagi[i]; //blad = suma wag wszystkich czujnikow
    ilosc_linii = ilosc_linii + czujniki[i]; //ile czujnikow widzi linie
  }

  if(ilosc_linii != 0){ // jesli widzimy linie
    blad = blad / ilosc_linii; //sredni blad
    poprzedni_blad = blad; //blad w przypadku zgubienia linii jest zapamietywany i wykorzystywany jako aktualny
  }
  else { //przy zgubieniu linii
    if(poprzedni_blad <=-20){ //przestrzelenie z jednej strony
      blad = -60;
      ostatni = 5;
    }
    else if(poprzedni_blad >=20) { //przestrzelenie z drugiej strony
      blad = 60;
      ostatni = 1;
    }
    else { //linia miedzy czujnikami
      blad = 0;
      ostatni = 3;
    }
  }
  return blad;
}


